Overview | Package | Class | Tree | Deprecated | Index | Help
| SolarMetric Kodo JDO 3.0.3 generated on February 20 2004
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## kodo.query
Interface KodoQuery

All Superinterfaces:
  Query, Serializable

All Known Implementing Classes:
  CacheAwareQuery

public interface KodoQuery
extends Query

Extension of the `Query` interface that adds some Kodo-specific methods.

Since:
  3.0

Field Summary
`static int` | `FLUSH_FALSE` Constant denoting that queries should never flush data to the database automatically before executing a query, but should instead execute queries in-memory if necessary.
`static int` | `FLUSH_TRUE` Constant denoting that queries should flush data to the database automatically whenever Kodo determines that relevant modifications have been made and IgnoreCache is `false`.
`static int` | `FLUSH_WITH_CONNECTION` Constant denoting that queries should flush data to the database automatically when Kodo determines that relevant modifications have been made and the current PersistenceManager already has a dedicated connection.

Method Summary
`ClassMetaData[]` | `getAccessPathMetaDatas()` Return an array of `ClassMetaData` for all classes involved in this query, or `null` if the access path for this query cannot be computed.
`boolean[]` | `getAscending()` For each expression returned by `getOrdering()`, return whether that expression is ascending.
`Class` | `getCandidateClass()` Return the class of the objects that this query will return, or `null` if this information is not available / not relevant.
`Collection` | `getCandidateCollection()` Return the candidate collection, or `null` if an extent was specified instead of a collection.
`KodoExtent` | `getCandidateExtent()` Return the candidate extent, or `null` if a collection was specified instead of an extent.
`FetchConfiguration` | `getFetchConfiguration()` Return the (mutable) fetch configuration for this query.
`String` | `getFilter()` Return the filter that this query has been configured with.
`String[]` | `getOrdering()` Return the ordering expressions that this query was configured with.
`String[][]` | `getParameterDeclarations()` Return a two-dimensional `String` array containing the parameter declarations for this query.
`String[]` | `getResult()` Return the result expressions set for this query.
`String[]` | `getResultAliases()` For each expression from `getResult()`, return the alias set for that expression.
`Class` | `getResultClass()` Returns the result class that has been set through `setResultClass(java.lang.Class)`, or null if none.
`void` | `registerListener(AggregateListener listener)` Register a filter listener for the query.
`void` | `registerListener(FilterListener listener)` Register a filter listener for the query.
`void` | `setResult(String data)` JDO 2.0 Preview.
`void` | `setResultClass(Class cls)` JDO 2.0 Preview.
`void` | `setUnique(boolean unique)` JDO 2.0 Preview.

Methods inherited from interface javax.jdo.Query
`close, closeAll, compile, declareImports, declareParameters, declareVariables, execute, execute, execute, execute, executeWithArray, executeWithMap, getIgnoreCache, getPersistenceManager, setCandidates, setCandidates, setClass, setFilter, setIgnoreCache, setOrdering`

Field Detail

### FLUSH_TRUE

    public static final int FLUSH_TRUE

  Constant denoting that queries should flush data to the database automatically whenever Kodo determines that relevant modifications have been made and IgnoreCache is `false`. See `JDOConfiguration.getFlushBeforeQueries()` for more info.

### FLUSH_FALSE

    public static final int FLUSH_FALSE

  Constant denoting that queries should never flush data to the database automatically before executing a query, but should instead execute queries in-memory if necessary. See `JDOConfiguration.getFlushBeforeQueries()` for more info.

### FLUSH_WITH_CONNECTION

    public static final int FLUSH_WITH_CONNECTION

  Constant denoting that queries should flush data to the database automatically when Kodo determines that relevant modifications have been made and the current PersistenceManager already has a dedicated connection. See `JDOConfiguration.getFlushBeforeQueries()` for more info.

Method Detail

### getFetchConfiguration

    public FetchConfiguration getFetchConfiguration()

  Return the (mutable) fetch configuration for this query.

### registerListener

    public void registerListener(FilterListener listener)

  Register a filter listener for the query.

### registerListener

    public void registerListener(AggregateListener listener)

  Register a filter listener for the query.

### getCandidateExtent

    public KodoExtent getCandidateExtent()

  Return the candidate extent, or `null` if a collection was specified instead of an extent.

### getCandidateCollection

    public Collection getCandidateCollection()

  Return the candidate collection, or `null` if an extent was specified instead of a collection.

### getCandidateClass

    public Class getCandidateClass()

  Return the class of the objects that this query will return, or `null` if this information is not available / not relevant.

### getFilter

    public String getFilter()

  Return the filter that this query has been configured with.

### getOrdering

    public String[] getOrdering()

  Return the ordering expressions that this query was configured with.

### getAscending

    public boolean[] getAscending()

  For each expression returned by `getOrdering()`, return whether that expression is ascending.

### getParameterDeclarations

    public String[][] getParameterDeclarations()

  Return a two-dimensional `String` array containing the parameter declarations for this query. For example, a query that has two `int` parameters called `foo` and `bar` would return `{ { "int", "foo" }, { "int", "bar" } }`. Returns `null` if there are no parameter declarations.

### getResult

    public String[] getResult()

  Return the result expressions set for this query.

### getResultAliases

    public String[] getResultAliases()

  For each expression from `getResult()`, return the alias set for that expression.

### getAccessPathMetaDatas

    public ClassMetaData[] getAccessPathMetaDatas()

  Return an array of `ClassMetaData` for all classes involved in this query, or `null` if the access path for this query cannot be computed.

### setUnique

    public void setUnique(boolean unique)

  JDO 2.0 Preview. Specify that only the first result of the query should be returned, rather than a collection. This method will return null if the query result size is 0.
  Since:
    3.0

### setResult

    public void setResult(String data)

  JDO 2.0 Preview. Configures what type of data this query should return. If this is unset or set to `null`, this query will return a list of the query's candidate class. Otherwise, this query will return aggregate function results and / or individual field values (projections).
  Parameters:
    `data` - a comma-delimited list of fields, functions on fields, or aggregate functions to return from this query
  Since:
    3.0

### setResultClass

    public void setResultClass(Class cls)

  JDO 2.0 Preview. Specify the type of object in which the result of invoking `Query.execute()` or one of its siblings. The behavior of this method depends the nature of the query being executed. In particular, if used in conjunction with `setResult(java.lang.String)`, the argument to this method should be `Object[].class`, a class with bean-like setters for each of the items listed in the result specification, or a class with a method called `put` with two `Object` arguments.

### getResultClass

    public Class getResultClass()

  Returns the result class that has been set through `setResultClass(java.lang.Class)`, or null if none.

Overview | Package | Class | Tree | Deprecated | Index | Help
| SolarMetric Kodo JDO 3.0.3 generated on February 20 2004
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 2001,2002 SolarMetric, Inc. All Rights Reserved.